"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var React = _interopRequireWildcard(require("react"));
var _core = require("../../core");
var _hooks = require("../../hooks");
var _Hint = _interopRequireDefault(require("../Hint"));
var _excluded = ["active"],
  _excluded2 = ["inputRef"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function Item(props) {
  var _useItem = (0, _hooks.useItem)(props),
    active = _useItem.active,
    itemProps = (0, _objectWithoutProperties2["default"])(_useItem, _excluded);
  return /*#__PURE__*/React.createElement("a", (0, _extends2["default"])({}, itemProps, {
    style: {
      background: active ? 'lightblue' : 'none',
      cursor: 'pointer',
      display: 'block',
      width: '100%'
    }
  }), props.children);
}
function BasicTypeahead(props) {
  var _useTypeahead = (0, _core.useTypeahead)(props),
    context = _useTypeahead.context,
    getInputProps = _useTypeahead.getInputProps,
    getMenuProps = _useTypeahead.getMenuProps,
    inputNode = _useTypeahead.inputNode,
    results = _useTypeahead.results;
  var _getInputProps = getInputProps({
      disabled: props.disabled,
      placeholder: props.placeholder
    }),
    inputRef = _getInputProps.inputRef,
    inputProps = (0, _objectWithoutProperties2["default"])(_getInputProps, _excluded2);
  var _useOverlay = (0, _hooks.useOverlay)(inputNode, {}),
    overlayRef = _useOverlay.innerRef,
    style = _useOverlay.style;
  return /*#__PURE__*/React.createElement(_core.TypeaheadContext.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(_Hint["default"], null, /*#__PURE__*/React.createElement("input", (0, _extends2["default"])({}, inputProps, {
    ref: inputRef
  }))), !!results.length && /*#__PURE__*/React.createElement("div", (0, _extends2["default"])({}, getMenuProps({
    className: 'menu',
    style: _objectSpread({
      border: '1px solid lightgray',
      maxHeight: '300px',
      overflow: 'auto'
    }, style)
  }), {
    ref: overlayRef
  }), results.map(function (result, idx) {
    return /*#__PURE__*/React.createElement(Item, {
      key: result,
      option: result,
      position: idx
    }, result);
  })));
}
var _default = exports["default"] = BasicTypeahead;