"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
var _core = require("../../core");
var _hooks = require("../../hooks");
var _ClearButton = _interopRequireDefault(require("../ClearButton"));
var _Loader = _interopRequireDefault(require("../Loader"));
var _Token = _interopRequireDefault(require("../Token"));
var _TypeaheadInputMulti = _interopRequireDefault(require("../TypeaheadInputMulti"));
var _TypeaheadInputSingle = _interopRequireDefault(require("../TypeaheadInputSingle"));
var _TypeaheadMenu = _interopRequireDefault(require("../TypeaheadMenu"));
var _utils = require("../../utils");
var _excluded = ["context"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var defaultRenderMenu = function defaultRenderMenu(results, menuProps, props) {
  return /*#__PURE__*/_react["default"].createElement(_TypeaheadMenu["default"], (0, _extends2["default"])({}, menuProps, {
    labelKey: props.labelKey,
    options: results,
    text: props.text
  }));
};
var defaultRenderToken = function defaultRenderToken(option, props, idx) {
  return /*#__PURE__*/_react["default"].createElement(_Token["default"], {
    disabled: props.disabled,
    key: idx,
    onRemove: props.onRemove,
    option: option,
    tabIndex: props.tabIndex
  }, (0, _utils.getOptionLabel)(option, props.labelKey));
};
var Typeahead = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _useTypeahead = (0, _core.useTypeahead)(props, ref),
    context = _useTypeahead.context,
    rest = (0, _objectWithoutProperties2["default"])(_useTypeahead, _excluded);
  var children = props.children,
    clearButton = props.clearButton,
    disabled = props.disabled,
    emptyLabel = props.emptyLabel,
    isLoading = props.isLoading,
    isInvalid = props.isInvalid,
    isValid = props.isValid,
    maxHeight = props.maxHeight,
    multiple = props.multiple,
    newSelectionPrefix = props.newSelectionPrefix,
    paginationText = props.paginationText,
    placeholder = props.placeholder,
    renderMenuItemChildren = props.renderMenuItemChildren,
    size = props.size;
  var getInputProps = rest.getInputProps,
    getMenuProps = rest.getMenuProps,
    isMenuShown = rest.isMenuShown,
    labelKey = rest.labelKey,
    onClear = rest.onClear,
    onRemove = rest.onRemove,
    results = rest.results,
    selected = rest.selected;
  var _useState = (0, _react.useState)(null),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    referenceElement = _useState2[0],
    setReferenceElement = _useState2[1];

  // Menu
  var overlayProps = (0, _hooks.useOverlay)(referenceElement, props);
  var renderMenu = props.renderMenu || defaultRenderMenu;
  var menuProps = _objectSpread(_objectSpread({
    emptyLabel: emptyLabel,
    maxHeight: maxHeight,
    newSelectionPrefix: newSelectionPrefix,
    paginationText: paginationText,
    renderMenuItemChildren: renderMenuItemChildren
  }, overlayProps), getMenuProps());
  function renderInput() {
    // TODO: Add warnings for conflicting input props.
    var inputProps = _objectSpread(_objectSpread({}, getInputProps(_objectSpread(_objectSpread({}, props.inputProps), {}, {
      disabled: disabled,
      placeholder: placeholder
    }))), {}, {
      referenceElementRef: setReferenceElement
    });
    if (props.renderInput) {
      return props.renderInput(inputProps, rest);
    }
    var commonProps = _objectSpread(_objectSpread({}, inputProps), {}, {
      isInvalid: isInvalid,
      isValid: isValid,
      size: size
    });
    if (!multiple) {
      return /*#__PURE__*/_react["default"].createElement(_TypeaheadInputSingle["default"], commonProps);
    }
    var renderToken = props.renderToken || defaultRenderToken;
    var tokenProps = _objectSpread(_objectSpread({}, commonProps), {}, {
      labelKey: labelKey,
      onRemove: onRemove
    });
    return /*#__PURE__*/_react["default"].createElement(_TypeaheadInputMulti["default"], (0, _extends2["default"])({}, commonProps, {
      placeholder: selected.length ? '' : inputProps.placeholder,
      selected: selected
    }), selected.map(function (option, idx) {
      return renderToken(option, tokenProps, idx);
    }));
  }
  var auxContent;
  if (isLoading) {
    auxContent = /*#__PURE__*/_react["default"].createElement(_Loader["default"], null);
  } else if (clearButton && !disabled && selected !== null && selected !== void 0 && selected.length) {
    auxContent = /*#__PURE__*/_react["default"].createElement(_ClearButton["default"], {
      onClick: onClear,
      onMouseDown: _utils.preventInputBlur,
      size: size
    });
  }
  return /*#__PURE__*/_react["default"].createElement(_core.TypeaheadContext.Provider, {
    value: context
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])('rbt', {
      'has-aux': !!auxContent,
      'is-invalid': isInvalid,
      'is-valid': isValid
    }, props.className),
    style: _objectSpread(_objectSpread({}, props.style), {}, {
      outline: 'none',
      position: 'relative'
    }),
    tabIndex: -1
  }, renderInput(), isMenuShown && renderMenu(results, menuProps, rest), auxContent && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])('rbt-aux', {
      'rbt-aux-lg': (0, _utils.isSizeLarge)(size)
    })
  }, auxContent), (0, _utils.isFunction)(children) ? children(rest) : children));
});
var _default = exports["default"] = Typeahead;