import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["active"],
  _excluded2 = ["inputRef"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
import * as React from 'react';
import { TypeaheadContext, useTypeahead } from '../../core';
import { useItem, useOverlay } from '../../hooks';
import Hint from '../Hint';
function Item(props) {
  var _useItem = useItem(props),
    active = _useItem.active,
    itemProps = _objectWithoutProperties(_useItem, _excluded);
  return /*#__PURE__*/React.createElement("a", _extends({}, itemProps, {
    style: {
      background: active ? 'lightblue' : 'none',
      cursor: 'pointer',
      display: 'block',
      width: '100%'
    }
  }), props.children);
}
function BasicTypeahead(props) {
  var _useTypeahead = useTypeahead(props),
    context = _useTypeahead.context,
    getInputProps = _useTypeahead.getInputProps,
    getMenuProps = _useTypeahead.getMenuProps,
    inputNode = _useTypeahead.inputNode,
    results = _useTypeahead.results;
  var _getInputProps = getInputProps({
      disabled: props.disabled,
      placeholder: props.placeholder
    }),
    inputRef = _getInputProps.inputRef,
    inputProps = _objectWithoutProperties(_getInputProps, _excluded2);
  var _useOverlay = useOverlay(inputNode, {}),
    overlayRef = _useOverlay.innerRef,
    style = _useOverlay.style;
  return /*#__PURE__*/React.createElement(TypeaheadContext.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(Hint, null, /*#__PURE__*/React.createElement("input", _extends({}, inputProps, {
    ref: inputRef
  }))), !!results.length && /*#__PURE__*/React.createElement("div", _extends({}, getMenuProps({
    className: 'menu',
    style: _objectSpread({
      border: '1px solid lightgray',
      maxHeight: '300px',
      overflow: 'auto'
    }, style)
  }), {
    ref: overlayRef
  }), results.map(function (result, idx) {
    return /*#__PURE__*/React.createElement(Item, {
      key: result,
      option: result,
      position: idx
    }, result);
  })));
}
export default BasicTypeahead;