import * as React from 'react';
import { TypeaheadContext, useTypeahead } from '../../core';
import { useItem, useOverlay } from '../../hooks';
import Hint from '../Hint';
function Item(props) {
    const { active, ...itemProps } = useItem(props);
    return (React.createElement("a", { ...itemProps, style: {
            background: active ? 'lightblue' : 'none',
            cursor: 'pointer',
            display: 'block',
            width: '100%',
        } }, props.children));
}
function BasicTypeahead(props) {
    const { context, getInputProps, getMenuProps, inputNode, results } = useTypeahead(props);
    const { inputRef, ...inputProps } = getInputProps({
        disabled: props.disabled,
        placeholder: props.placeholder,
    });
    const { innerRef: overlayRef, style } = useOverlay(inputNode, {});
    return (React.createElement(TypeaheadContext.Provider, { value: context },
        React.createElement(Hint, null,
            React.createElement("input", { ...inputProps, ref: inputRef })),
        !!results.length && (React.createElement("div", { ...getMenuProps({
                className: 'menu',
                style: {
                    border: '1px solid lightgray',
                    maxHeight: '300px',
                    overflow: 'auto',
                    ...style,
                },
            }), ref: overlayRef }, results.map((result, idx) => (React.createElement(Item, { key: result, option: result, position: idx }, result)))))));
}
export default BasicTypeahead;
