import { LabelKey, Option, TypeaheadState } from '../types';
interface Props {
    defaultInputValue: string;
    defaultOpen: boolean;
    defaultSelected: Option[];
    maxResults: number;
    multiple: boolean;
    labelKey: LabelKey;
    selected?: Option[];
}
type State = TypeaheadState;
type NewStateObject = Partial<State>;
type NewStateCallback = (state: State, props: Props) => Partial<State>;
type PostUpdateCallback = (state: State) => void;
export declare function getInitialState({ defaultInputValue, defaultOpen, defaultSelected, labelKey, maxResults, multiple, ...props }: Props): {
    activeIndex: number;
    activeItem: undefined;
    initialItem: undefined;
    isFocused: boolean;
    selected: Option[];
    showMenu: boolean;
    shownResults: number;
    text: string;
};
export declare function clearTypeahead(state: State, props: Props): {
    isFocused: boolean;
    selected: never[];
    text: string;
    activeIndex: number;
    activeItem: undefined;
    initialItem: undefined;
    showMenu: boolean;
    shownResults: number;
};
export declare function clickOrFocusInput(state: State): {
    isFocused: boolean;
    showMenu: boolean;
    activeIndex: number;
    activeItem?: Option | undefined;
    initialItem?: Option | undefined;
    selected: Option[];
    shownResults: number;
    text: string;
};
export declare function hideMenu(state: State, props: Props): {
    activeIndex: number;
    activeItem: undefined;
    initialItem: undefined;
    showMenu: boolean;
    shownResults: number;
    isFocused: boolean;
    selected: Option[];
    text: string;
};
export declare function toggleMenu(state: State, props: Props): {
    showMenu: boolean;
    activeIndex: number;
    activeItem?: Option | undefined;
    initialItem?: Option | undefined;
    isFocused: boolean;
    selected: Option[];
    shownResults: number;
    text: string;
};
export declare function useTypeaheadState(props: Props): readonly [{
    activeIndex: number;
    activeItem?: Option | undefined;
    initialItem?: Option | undefined;
    isFocused: boolean;
    selected: Option[];
    showMenu: boolean;
    shownResults: number;
    text: string;
}, (stateObjOrFn: NewStateObject | NewStateCallback, cb?: PostUpdateCallback) => void];
export {};
