import { ChangeEvent, ReactNode } from 'react';
import { TypeaheadComponentProps } from '../components/Typeahead';
import type { Option } from '../types';
export interface UseAsyncProps extends TypeaheadComponentProps {
    delay?: number;
    isLoading: boolean;
    onSearch: (query: string) => void;
    promptText?: ReactNode;
    searchText?: ReactNode;
    useCache?: boolean;
}
declare function useAsync(props: UseAsyncProps): {
    allowNew: boolean | ((options: Option[], state: import("../types").TypeaheadPropsAndState) => boolean) | undefined;
    emptyLabel: ReactNode;
    isLoading: boolean;
    minLength: number;
    onInputChange: (query: string, e: ChangeEvent<HTMLInputElement>) => void;
    options: Option[];
    align?: "justify" | "left" | "right" | undefined;
    className?: string | undefined;
    clearButton?: boolean | undefined;
    disabled?: boolean | undefined;
    dropup?: boolean | undefined;
    flip?: boolean | undefined;
    isInvalid?: boolean | undefined;
    isValid?: boolean | undefined;
    maxHeight?: string | undefined;
    newSelectionPrefix?: ReactNode;
    paginationText?: ReactNode;
    placeholder?: string | undefined;
    positionFixed?: boolean | undefined;
    renderInput?: ((inputProps: import("../types").TypeaheadInputProps, props: import("../types").TypeaheadChildProps) => JSX.Element) | undefined;
    renderMenu?: ((results: Option[], menuProps: import("../components/Typeahead").RenderMenuProps, state: import("../types").TypeaheadChildProps) => JSX.Element) | undefined;
    renderMenuItemChildren?: import("..").RenderMenuItemChildren | undefined;
    renderToken?: import("../types").RenderToken | undefined;
    size?: "lg" | "sm" | undefined;
    style?: import("react").CSSProperties | undefined;
    autoFocus?: boolean | undefined;
    caseSensitive?: boolean | undefined;
    children?: import("../types").TypeaheadChildren;
    defaultInputValue?: string | undefined;
    defaultOpen?: boolean | undefined;
    defaultSelected?: Option[] | undefined;
    filterBy?: import("../types").FilterByCallback | string[] | undefined;
    highlightOnlyResult?: boolean | undefined;
    id?: string | undefined;
    ignoreDiacritics?: boolean | undefined;
    inputProps?: import("../types").InputProps | undefined;
    labelKey?: import("../types").LabelKey | undefined;
    maxResults?: number | undefined;
    multiple?: boolean | undefined;
    onBlur?: import("react").FocusEventHandler<HTMLInputElement> | undefined;
    onChange?: ((selected: Option[]) => void) | undefined;
    onFocus?: import("react").FocusEventHandler<HTMLInputElement> | undefined;
    onKeyDown?: import("react").KeyboardEventHandler<HTMLInputElement> | undefined;
    onMenuToggle?: ((isOpen: boolean) => void) | undefined;
    onPaginate?: ((event: import("../types").SelectEvent<HTMLElement>, shownResults: number) => void) | undefined;
    open?: boolean | undefined;
    paginate?: boolean | undefined;
    selected?: Option[] | undefined;
    selectHint?: import("../types").SelectHint | undefined;
};
export default useAsync;
