import { FocusEvent, FocusEventHandler, HTMLProps, KeyboardEvent, MouseEvent, MouseEventHandler } from 'react';
import { Option, OptionHandler } from '../types';
export interface UseTokenProps<T> extends Omit<HTMLProps<T>, 'onBlur'> {
    onBlur?: (event: Event) => void;
    onClick?: MouseEventHandler<T>;
    onFocus?: FocusEventHandler<T>;
    onRemove?: OptionHandler;
    option: Option;
}
declare function useToken<T extends HTMLElement>({ onBlur, onClick, onFocus, onRemove, option, ...props }: UseTokenProps<T>): {
    active: boolean;
    onBlur: (e: Event) => void;
    onClick: (e: MouseEvent<T>) => void;
    onFocus: (e: FocusEvent<T>) => void;
    onKeyDown: (e: KeyboardEvent<T>) => void;
    onRemove: (() => void) | undefined;
    ref: import("react").MutableRefObject<HTMLDivElement | null>;
};
export default useToken;
