import cx from 'classnames';
import getMenuItemId from './getMenuItemId';
const getInputProps = ({ activeIndex, id, isFocused, isMenuShown, multiple, onClick, onFocus, ...props }) => ({ className, ...inputProps } = {}) => {
    return {
        autoComplete: 'off',
        type: 'text',
        ...inputProps,
        ...props,
        'aria-activedescendant': activeIndex >= 0 ? getMenuItemId(id, activeIndex) : undefined,
        'aria-autocomplete': 'both',
        'aria-expanded': isMenuShown,
        'aria-haspopup': 'listbox',
        'aria-multiselectable': multiple || undefined,
        'aria-owns': isMenuShown ? id : undefined,
        className: cx({
            [className || '']: !multiple,
            focus: isFocused,
        }),
        ...(multiple && { inputClassName: className }),
        onClick,
        onFocus,
        role: 'combobox',
    };
};
export default getInputProps;
